Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34921)
@@ -1770,10 +744,9 @@
                             # must keep same directory size to avoid messing up our fixed offsets
                             $dirBuff .= ("\0" x 12) if $$dirInfo{FixBase};
-WroteIt:                    ++$index;
+                            ++$index;
                             $newID = $oldID;    # pretend we wrote this
                             next;
                         }
-                        my $msg = "Bad format ($oldFormat) for $name entry $index";
-                        return ExifErr($exifTool, $msg, $tagTablePtr);
+                        return ExifErr($et, $msg, $tagTablePtr);
                     }
                     $readFormName = $oldFormName = $formatName[$oldFormat];
@@ -1787,7 +760,7 @@
                         # must get unknown tags too
                         # (necessary so we don't miss a tag we want to Drop)
-                        my $unk = $exifTool->Options(Unknown => 1);
-                        $oldInfo = $exifTool->GetTagInfo($tagTablePtr, $oldID);
-                        $exifTool->Options(Unknown => $unk);
+                        my $unk = $et->Options(Unknown => 1);
+                        $oldInfo = $et->GetTagInfo($tagTablePtr, $oldID);
+                        $et->Options(Unknown => $unk);
                     }
                     # patch incorrect count in Kodak SubIFD3 tags
@@ -1812,9 +785,9 @@
                             eval $$dirInfo{FixOffsets};
                             unless (defined $valuePtr) {
-                                unless ($$exifTool{DROP_TAGS}) {
-                                    my $tagStr = $oldInfo ? $$oldInfo{Name} : sprintf("tag 0x%x",$oldID);
-                                    return undef if $exifTool->Error("Bad $name offset for $tagStr", $inMakerNotes);
+                                unless ($$et{DropTags}) {
+                                    my $tagStr = $oldInfo ? $$oldInfo{Name} : sprintf("tag 0x%.4x",$oldID);
+                                    return undef if $et->Error("Bad $name offset for $tagStr", $inMakerNotes);
                                 }
-                                goto DropTag;
+                                ++$index;  $oldID = $newID;  next;  # drop this tag
                             }
                         }
@@ -1823,5 +796,5 @@
                         # convert offset to pointer in $$dataPt
                         if ($$dirInfo{EntryBased} or (ref $$tagTablePtr{$oldID} eq 'HASH' and
-                            $tagTablePtr->{$oldID}{EntryBased}))
+                            $$tagTablePtr{$oldID}{EntryBased}))
                         {
                             $valuePtr += $entry;
@@ -1833,16 +806,20 @@
                         # get value by seeking in file if we are allowed
                         if ($valuePtr < 0 or $valuePtr+$oldSize > $dataLen) {
-                            my ($pos, $tagStr, $invalidPreview, $tmpInfo);
+                            my ($pos, $tagStr, $invalidPreview, $tmpInfo, $leicaTrailer);
                             if ($oldInfo) {
                                 $tagStr = $$oldInfo{Name};
+                                $leicaTrailer = $$oldInfo{LeicaTrailer};
                             } elsif (defined $oldInfo) {
-                                $tmpInfo = $exifTool->GetTagInfo($tagTablePtr, $oldID, \ '', $oldFormName, $oldCount);
-                                $tagStr = $$tmpInfo{Name} if $tmpInfo;
-                            }
-                            $tagStr or $tagStr = sprintf("tag 0x%x",$oldID);
+                                $tmpInfo = $et->GetTagInfo($tagTablePtr, $oldID, \ '', $oldFormName, $oldCount);
+                                if ($tmpInfo) {
+                                    $tagStr = $$tmpInfo{Name};
+                                    $leicaTrailer = $$tmpInfo{LeicaTrailer};
+                                }
+                            }
+                            $tagStr or $tagStr = sprintf("tag 0x%.4x",$oldID);
                             # allow PreviewImage to run outside EXIF segment in JPEG images
                             if (not $raf) {
                                 if ($tagStr eq 'PreviewImage') {
-                                    $raf = $exifTool->{RAF};
+                                    $raf = $$et{RAF};
                                     if ($raf) {
                                         $pos = $raf->Tell();
@@ -1856,10 +833,11 @@
                                         $invalidPreview = 1;
                                     }
-                                } elsif ($tagStr eq 'MakerNoteLeica6') {
+                                } elsif ($leicaTrailer) {
                                     # save information about Leica makernote trailer
-                                    $$exifTool{LeicaTrailer} = {
+                                    $$et{LeicaTrailer} = {
                                         TagInfo => $oldInfo || $tmpInfo,
                                         Offset  => $base + $valuePtr + $dataPos,
                                         Size    => $oldSize,
+                                        Fixup   => new Image::ExifTool::Fixup,
                                     },
                                     $invalidPreview = 2;
@@ -1872,10 +850,11 @@
                             }
                             if ($oldSize > BINARY_DATA_LIMIT and $$origDirInfo{ImageData} and
-                                (not defined $oldInfo or ($oldInfo and not $$oldInfo{SubDirectory})))
+                                (not defined $oldInfo or ($oldInfo and
+                                (not $$oldInfo{SubDirectory} or $$oldInfo{ReadFromRAF}))))
                             {
                                 # copy huge data blocks later instead of loading into memory
                                 $oldValue = ''; # dummy empty value
                                 # copy this value later unless writing a new value
-                                unless ($set{$oldID}) {
+                                unless (defined $set{$oldID}) {
                                     my $pad = $oldSize & 0x01 ? 1 : 0;
                                     # save block information to copy later (set directory offset later)
@@ -1895,14 +874,14 @@
                                 }
                                 unless ($success) {
-                                    return undef if $exifTool->Error("Error reading value for $name entry $index", $inMakerNotes);
-                                    goto DropTag;
+                                    return undef if $et->Error("Error reading value for $name entry $index", $inMakerNotes);
+                                    ++$index;  $oldID = $newID;  next;  # drop this tag
                                 }
                             } elsif (not $invalidPreview) {
-                                return undef if $exifTool->Error("Bad $name offset for $tagStr", $inMakerNotes);
-                                goto DropTag;
+                                return undef if $et->Error("Bad $name offset for $tagStr", $inMakerNotes);
+                                ++$index;  $oldID = $newID;  next;  # drop this tag
                             }
                             if ($invalidPreview) {
                                 # set value for invalid preview
-                                if ($exifTool->{FILE_TYPE} eq 'JPEG') {
+                                if ($$et{FILE_TYPE} eq 'JPEG') {
                                     # define dummy value for preview (or Leica MakerNote) to write later
                                     # (value must be larger than 4 bytes to generate PREVIEW_INFO,
@@ -1915,5 +894,5 @@
                                 $valuePtr = 0;
                             } else {
-                                UpdateTiffEnd($exifTool, $base+$valuePtr+$dataPos+$oldSize);
+                                UpdateTiffEnd($et, $base+$valuePtr+$dataPos+$oldSize);
                             }
                             # update pointers for value just read from file
@@ -1928,7 +907,7 @@
                             my $str = "Suspicious $name offset for $tagStr";
                             if ($inMakerNotes) {
-                                $exifTool->Warn($str, 1);
+                                $et->Warn($str, 1);
                             } else {
-                                return undef if $exifTool->Error($str, 1);
+                                return undef if $et->Error($str, 1);
                             }
                         }
@@ -1938,7 +917,22 @@
                     # get tagInfo using value if necessary
                     if (defined $oldInfo and not $oldInfo) {
-                        my $unk = $exifTool->Options(Unknown => 1);
-                        $oldInfo = $exifTool->GetTagInfo($tagTablePtr, $oldID, \$oldValue, $oldFormName, $oldCount);
-                        $exifTool->Options(Unknown => $unk);
+                        my $unk = $et->Options(Unknown => 1);
+                        $oldInfo = $et->GetTagInfo($tagTablePtr, $oldID, \$oldValue, $oldFormName, $oldCount);
+                        $et->Options(Unknown => $unk);
+                        # now that we have the value, we can resolve the Condition to finally
+                        # determine whether we want to delete this tag or not
+                        if ($mayDelete{$oldID} and $oldInfo and (not @newTags or $newTags[0] != $oldID)) {
+                            my $nvHash = $et->GetNewValueHash($oldInfo, $dirName);
+                            if (not $nvHash and $wrongDir) {
+                                # delete from wrong directory if necessary
+                                $nvHash = $et->GetNewValueHash($oldInfo, $wrongDir);
+                                $nvHash and $xDelete{$oldID} = 1;
+                            }
+                            if ($nvHash) {
+                                # we want to delete this tag after all, so insert it into our list
+                                $set{$oldID} = $oldInfo;
+                                unshift @newTags, $oldID;
+                            }
+                        }
                     }
                     # make sure we are handling the 'ifd' format properly
@@ -1947,5 +941,5 @@
                     {
                         my $str = sprintf('%s tag 0x%.4x IFD format not handled', $name, $oldID);
-                        $exifTool->Error($str, $inMakerNotes);
+                        $et->Error($str, $inMakerNotes);
                     }
                     # override format we use to read the value if specified
@@ -1955,12 +949,11 @@
                             not $intFormat{$oldFormName})
                         {
-                            $exifTool->Error("Invalid format ($oldFormName) for $name $$oldInfo{Name}", $inMakerNotes);
-                            goto DropTag;
-                        }
-                        if ($$oldInfo{Drop} and $$exifTool{DROP_TAGS}) {
-                            # don't rewrite this tag
-DropTag:                    ++$index;
-                            $oldID = $newID;
-                            next;
+                            $et->Error("Invalid format ($oldFormName) for $name $$oldInfo{Name}", $inMakerNotes);
+                            ++$index;  $oldID = $newID;  next;  # drop this tag
+                        }
+                        if ($$oldInfo{Drop} and $$et{DropTags} and
+                            ($$oldInfo{Drop} == 1 or $$oldInfo{Drop} < $oldSize))
+                        {
+                            ++$index;  $oldID = $newID;  next;  # drop this tag
                         }
                         if ($$oldInfo{Format}) {
@@ -1972,4 +965,8 @@
                                 $readFormat = $oldFormat;
                             }
+                            if ($$oldInfo{FixedSize}) {
+                                $oldSize = $$oldInfo{FixedSize} if $$oldInfo{FixedSize};
+                                $oldValue = substr($$valueDataPt, $valuePtr, $oldSize);
+                            }
                             # adjust number of items to read if format size changed
                             $readCount = $oldSize / $formatSize[$readFormat];
@@ -1979,7 +976,9 @@
                         my $str = $oldInfo ? "$$oldInfo{Name} tag" : sprintf('tag 0x%x',$oldID);
                         if ($oldID == $lastTagID) {
-                            $exifTool->Warn("Duplicate $str in $name");;
+                            $et->Warn("Duplicate $str in $name");
+                            # put this tag back into the newTags list if necessary
+                            unshift @newTags, $oldID if defined $set{$oldID};
                         } else {
-                            $exifTool->Warn("\u$str out of sequence in $name");
+                            $et->Warn("\u$str out of sequence in $name");
                         }
                     }
@@ -2000,5 +999,5 @@
             } elsif (not defined $newID) {
                 # maker notes will have no new tags defined
-                if ($set{$oldID}) {
+                if (defined $set{$oldID}) {
                     $newID = $oldID;
                     $isNew = 0;
@@ -2021,4 +1020,76 @@
                 # add, edit or delete this tag
                 shift @newTags; # remove from list
+                my $curInfo = $set{$newID};
+                unless ($curInfo or $$addDirs{$newID}) {
+                    # we can finally get the specific tagInfo reference for this tag
+                    # (because we can now evaluate the Condition statement since all
+                    #  DataMember's have been obtained for tags up to this one)
+                    $curInfo = $et->GetTagInfo($tagTablePtr, $newID);
+                    if (defined $curInfo and not $curInfo) {
+                        # need value to evaluate the condition
+                        # (tricky because we need the tagInfo ref to get the value,
+                        #  so we must loop through all new tagInfo's...)
+                        foreach $tagInfo (@newTagInfo) {
+                            next unless $$tagInfo{TagID} == $newID;
+                            my $val = $et->GetNewValue($tagInfo);
+                            defined $val or $mayDelete{$newID} = 1, next;
+                            # must convert to binary for evaluating in Condition
+                            my $fmt = $$tagInfo{Format} || $$tagInfo{Writable};
+                            if ($fmt) {
+                                $val = WriteValue($val, $fmt, $$tagInfo{Count});
+                                defined $val or $mayDelete{$newID} = 1, next;
+                            }
+                            $curInfo = $et->GetTagInfo($tagTablePtr, $newID, \$val, $oldFormName, $oldCount);
+                            if ($curInfo) {
+                                last if $curInfo eq $tagInfo;
+                                undef $curInfo;
+                            }
+                        }
+                        # may want to delete this, but we need to see the old value first
+                        $mayDelete{$newID} = 1 unless $curInfo;
+                    }
+                    # don't set this tag unless valid for the current condition
+                    if ($curInfo and $$et{NEW_VALUE}{$curInfo}) {
+                        $set{$newID} = $curInfo;
+                    } else {
+                        next if $isNew > 0;
+                        $isNew = -1;
+                        undef $curInfo;
+                    }
+                }
+                if ($curInfo) {
+                    if ($$curInfo{WriteCondition}) {
+                        my $self = $et;   # set $self to be used in eval
+                        #### eval WriteCondition ($self)
+                        unless (eval $$curInfo{WriteCondition}) {
+                            $@ and warn $@;
+                            goto NoWrite;   # GOTO !
+                        }
+                    }
+                    my $nvHash;
+                    $nvHash = $et->GetNewValueHash($curInfo, $dirName) if $isNew >= 0;
+                    unless ($nvHash or defined $$mandatory{$newID}) {
+                        goto NoWrite unless $wrongDir;  # GOTO !
+                        # delete stuff from the wrong directory if setting somewhere else
+                        $nvHash = $et->GetNewValueHash($curInfo, $wrongDir);
+                        # don't cross delete if not overwriting
+                        goto NoWrite unless $et->IsOverwriting($nvHash);    # GOTO !
+                        # don't cross delete if specifically deleting from the other directory
+                        # (Note: don't call GetValue() here because it shouldn't be called
+                        #  if IsOverwriting returns < 0 -- eg. when shifting)
+                        if (not defined $$nvHash{Value} and $$nvHash{WantGroup} and
+                                lc($$nvHash{WantGroup}) eq lc($wrongDir))
+                        {
+                            goto NoWrite;   # GOTO !
+                        } else {
+                            # remove this tag if found in this IFD
+                            $xDelete{$newID} = 1;
+                        }
+                    }
+                } elsif (not $$addDirs{$newID}) {
+NoWrite:            next if $isNew > 0;
+                    delete $set{$newID};
+                    $isNew = -1;
+                }
                 if ($set{$newID}) {
 #
@@ -2028,14 +1099,14 @@
                     $newCount = $$newInfo{Count};
                     my ($val, $newVal, $n);
-                    my $nvHash = $exifTool->GetNewValueHash($newInfo, $dirName);
+                    my $nvHash = $et->GetNewValueHash($newInfo, $dirName);
                     if ($isNew > 0) {
                         # don't create new entry unless requested
                         if ($nvHash) {
-                            next unless Image::ExifTool::IsCreating($nvHash);
+                            next unless $$nvHash{IsCreating};
                             if ($$newInfo{IsOverwriting}) {
                                 my $proc = $$newInfo{IsOverwriting};
-                                $isOverwriting = &$proc($exifTool, $nvHash, $val, \$newVal);
+                                $isOverwriting = &$proc($et, $nvHash, $val, \$newVal);
                             } else {
-                                $isOverwriting = Image::ExifTool::IsOverwriting($nvHash);
+                                $isOverwriting = $et->IsOverwriting($nvHash);
                             }
                         } else {
@@ -2059,8 +1130,12 @@
                     } elsif ($nvHash or $xDelete{$newID}) {
                         unless ($nvHash) {
-                            $nvHash = $exifTool->GetNewValueHash($newInfo, $wrongDir);
+                            $nvHash = $et->GetNewValueHash($newInfo, $wrongDir);
                         }
                         # read value
-                        $val = ReadValue(\$oldValue, 0, $readFormName, $readCount, $oldSize);
+                        if (length $oldValue >= $oldSize) {
+                            $val = ReadValue(\$oldValue, 0, $readFormName, $readCount, $oldSize);
+                        } else {
+                            $val = '';
+                        }
                         # determine write format (by default, use 'Writable' format)
                         my $writable = $$newInfo{Writable};
@@ -2088,20 +1163,21 @@
                         if ($$newInfo{IsOverwriting}) {
                             my $proc = $$newInfo{IsOverwriting};
-                            $isOverwriting = &$proc($exifTool, $nvHash, $val, \$newVal);
+                            $isOverwriting = &$proc($et, $nvHash, $val, \$newVal);
                         } else {
-                            $isOverwriting = Image::ExifTool::IsOverwriting($nvHash, $val);
+                            $isOverwriting = $et->IsOverwriting($nvHash, $val);
                         }
                     }
                     if ($isOverwriting) {
-                        $newVal = Image::ExifTool::GetNewValues($nvHash) unless defined $newVal;
+                        $newVal = $et->GetNewValue($nvHash) unless defined $newVal;
                         # value undefined if deleting this tag
                         # (also delete tag if cross-deleting and this isn't a date/time shift)
                         if (not defined $newVal or ($xDelete{$newID} and not defined $$nvHash{Shift})) {
-                            if ($$newInfo{RawConvInv} and defined $$nvHash{Value}) {
-                                goto NoOverwrite;   # error in RawConvInv, so rewrite existing tag
+                            if (not defined $newVal and $$newInfo{RawConvInv} and defined $$nvHash{Value}) {
+                                # error in RawConvInv, so rewrite existing tag
+                                goto NoOverwrite; # GOTO!
                             }
                             unless ($isNew) {
-                                ++$exifTool->{CHANGED};
-                                $exifTool->VerboseValue("- $dirName:$$newInfo{Name}", $val);
+                                ++$$et{CHANGED};
+                                $et->VerboseValue("- $dirName:$$newInfo{Name}", $val);
                             }
                             next;
@@ -2115,24 +1191,27 @@
                         $newValue = WriteValue($newVal, $newFormName, $newCount);
                         unless (defined $newValue) {
-                            $exifTool->Warn("Error writing $dirName:$$newInfo{Name}");
-                            goto NoOverwrite;
+                            $et->Warn("Invalid value for $dirName:$$newInfo{Name}");
+                            goto NoOverwrite; # GOTO!
                         }
                         if (length $newValue) {
                             # limit maximum value length in JPEG images
                             # (max segment size is 65533 bytes and the min EXIF size is 96 incl an additional IFD entry)
-                            if ($$exifTool{FILE_TYPE} eq 'JPEG' and length($newValue) > 65436 and
+                            if ($$et{FILE_TYPE} eq 'JPEG' and length($newValue) > 65436 and
                                 $$newInfo{Name} ne 'PreviewImage')
                             {
                                 my $name = $$newInfo{MakerNotes} ? 'MakerNotes' : $$newInfo{Name};
-                                $exifTool->Warn("$name too large to write in JPEG segment");
-                                goto NoOverwrite;
+                                $et->Warn("Writing large value for $name",1);
+                            }
+                            # re-code if necessary
+                            if ($strEnc and $newFormName eq 'string') {
+                                $newValue = $et->Encode($newValue, $strEnc);
                             }
                         } else {
-                            $exifTool->Warn("Can't write zero length $$newInfo{Name} in $tagTablePtr->{GROUPS}{1}");
-                            goto NoOverwrite;
+                            $et->Warn("Can't write zero length $$newInfo{Name} in $$tagTablePtr{GROUPS}{1}");
+                            goto NoOverwrite; # GOTO!
                         }
                         if ($isNew >= 0) {
                             $newCount = length($newValue) / $formatSize[$newFormat];
-                            ++$exifTool->{CHANGED};
+                            ++$$et{CHANGED};
                             if (defined $allMandatory) {
                                 # not all mandatory if we are writing any tag specifically
@@ -2145,7 +1224,11 @@
                             }
                             if ($verbose > 1) {
-                                $exifTool->VerboseValue("- $dirName:$$newInfo{Name}", $val) unless $isNew;
-                                my $str = $nvHash ? '' : ' (mandatory)';
-                                $exifTool->VerboseValue("+ $dirName:$$newInfo{Name}", $newVal, $str);
+                                $et->VerboseValue("- $dirName:$$newInfo{Name}", $val) unless $isNew;
+                                if ($$newInfo{OffsetPair} and $newVal eq '4277010157') { # (0xfeedfeed)
+                                    print { $$et{OPTIONS}{TextOut} } "    + $dirName:$$newInfo{Name} = <tbd>\n";
+                                } else {
+                                    my $str = $nvHash ? '' : ' (mandatory)';
+                                    $et->VerboseValue("+ $dirName:$$newInfo{Name}", $newVal, $str);
+                                }
                             }
                         }
@@ -2165,5 +1248,5 @@
 #
                     # newInfo may not be defined if we try to add a mandatory tag
-                    # to a directory that doesn't support it (ie. IFD1 in RW2 images)
+                    # to a directory that doesn't support it (eg. IFD1 in RW2 images)
                     $newInfo = $$addDirs{$newID} or next;
                     # make sure we don't try to generate a new MakerNotes directory
@@ -2171,6 +1254,6 @@
                     next if $$newInfo{MakerNotes} or $$newInfo{Name} eq 'SubIFD';
                     my $subTable;
-                    if ($newInfo->{SubDirectory}{TagTable}) {
-                        $subTable = Image::ExifTool::GetTagTable($newInfo->{SubDirectory}{TagTable});
+                    if ($$newInfo{SubDirectory}{TagTable}) {
+                        $subTable = Image::ExifTool::GetTagTable($$newInfo{SubDirectory}{TagTable});
                     } else {
                         $subTable = $tagTablePtr;
@@ -2181,6 +1264,6 @@
                         Fixup => new Image::ExifTool::Fixup,
                     );
-                    $sourceDir{DirName} = $newInfo->{Groups}{1} if $$newInfo{SubIFD};
-                    $newValue = $exifTool->WriteDirectory(\%sourceDir, $subTable);
+                    $sourceDir{DirName} = $$newInfo{Groups}{1} if $$newInfo{SubIFD};
+                    $newValue = $et->WriteDirectory(\%sourceDir, $subTable);
                     # only add new directory if it isn't empty
                     next unless defined $newValue and length($newValue);
@@ -2214,4 +1297,8 @@
                     $newFormName = $$newInfo{Writable};
                     $newFormat = $formatNumber{$newFormName};
+                } elsif ($$addDirs{$newID} and $newInfo ne $$addDirs{$newID}) {
+                    # this can happen if we are trying to add a directory that doesn't exist
+                    # in this type of file (eg. try adding a SubIFD tag to an A100 image)
+                    $isNew = -1;
                 }
             }
@@ -2240,6 +1327,6 @@
                         # prefer tag from Composite table if it exists (otherwise
                         # PreviewImage data would be taken from Extra tag)
-                        my $compInfo = $Image::ExifTool::Composite{$dataTag};
-                        $offsetData{$dataTag} = $exifTool->GetNewValues($compInfo || $dataTag);
+                        my $compInfo = Image::ExifTool::GetCompositeTagInfo($dataTag);
+                        $offsetData{$dataTag} = $et->GetNewValue($compInfo || $dataTag);
                         my $err;
                         if (defined $offsetData{$dataTag}) {
@@ -2247,8 +1334,5 @@
                             if ($dataTag eq 'PreviewImage') {
                                 # must set DEL_PREVIEW flag now if preview fit into IFD
-                                $$exifTool{DEL_PREVIEW} = 1 if $len <= 4;
-                            } elsif ($exifTool->{FILE_TYPE} eq 'JPEG' and $len > 60000) {
-                                delete $offsetData{$dataTag};
-                                $err = "$dataTag not written (too large for JPEG segment)";
+                                $$et{DEL_PREVIEW} = 1 if $len <= 4;
                             }
                         } else {
@@ -2256,5 +1340,5 @@
                         }
                         if ($err) {
-                            $exifTool->Warn($err) if $$newInfo{IsOffset};
+                            $et->Warn($err) if $$newInfo{IsOffset};
                             delete $set{$newID};    # remove from list of tags we are setting
                             next;
@@ -2267,23 +1351,27 @@
                 if ($$newInfo{MakerNotes}) {
                     # don't write new makernotes if we are deleting this group
-                    if ($exifTool->{DEL_GROUP}{MakerNotes} and
-                       ($exifTool->{DEL_GROUP}{MakerNotes} != 2 or $isNew <= 0))
+                    if ($$et{DEL_GROUP}{MakerNotes} and
+                       ($$et{DEL_GROUP}{MakerNotes} != 2 or $isNew <= 0))
                     {
-                        if ($isNew <= 0) {
-                            ++$exifTool->{CHANGED};
-                            $verbose and print $out "  Deleting MakerNotes\n";
-                        }
-                        next;
+                        if ($et->IsRawType()) {
+                            $et->WarnOnce("Can't delete MakerNotes from $$et{FileType}",1);
+                        } else {
+                            if ($isNew <= 0) {
+                                ++$$et{CHANGED};
+                                $verbose and print $out "  Deleting MakerNotes\n";
+                            }
+                            next;
+                        }
                     }
                     my $saveOrder = GetByteOrder();
-                    if ($isNew >= 0 and $set{$newID}) {
+                    if ($isNew >= 0 and defined $set{$newID}) {
                         # we are writing a whole new maker note block
                         # --> add fixup information if necessary
-                        my $nvHash = $exifTool->GetNewValueHash($newInfo, $dirName);
-                        if ($nvHash and $nvHash->{MAKER_NOTE_FIXUP}) {
+                        my $nvHash = $et->GetNewValueHash($newInfo, $dirName);
+                        if ($nvHash and $$nvHash{MAKER_NOTE_FIXUP}) {
                             # must clone fixup because we will be shifting it
-                            my $makerFixup = $nvHash->{MAKER_NOTE_FIXUP}->Clone();
+                            my $makerFixup = $$nvHash{MAKER_NOTE_FIXUP}->Clone();
                             my $valLen = length($valBuff);
-                            $makerFixup->{Start} += $valLen;
+                            $$makerFixup{Start} += $valLen;
                             push @valFixups, $makerFixup;
                         }
@@ -2311,4 +1399,5 @@
                             $subdirInfo{NoFixBase} = 1 if defined $$sub{Base};
                             $subdirInfo{AutoFix} = $$sub{AutoFix};
+                            SetByteOrder($$sub{ByteOrder}) if $$sub{ByteOrder};
                         }
                         # get the proper tag table for these maker notes
